import java.util.Arrays;
import java.util.List;
import javax.xml.stream.XMLEventFactory;
import javax.xml.stream.XMLEventWriter;
import javax.xml.stream.XMLOutputFactory;
import javax.xml.stream.events.Attribute;
import javax.xml.stream.events.Characters;
import javax.xml.stream.events.EndDocument;
import javax.xml.stream.events.EndElement;
import javax.xml.stream.events.StartDocument;
import javax.xml.stream.events.StartElement;

public class XMLEventWriterDemo {
    public static void main(String[] args) throws Exception {
        // Create XMLOutputFactory
        XMLOutputFactory outputFactory =
                XMLOutputFactory.newInstance();
        
        // Create XMLEventWriter
        XMLEventWriter writer =
                outputFactory.createXMLEventWriter(System.out);
        
        // Create XMLEventFactory
        XMLEventFactory xmlEventFactory =
                XMLEventFactory.newInstance();
        
        // Create document
        StartDocument startDocument = xmlEventFactory.
                createStartDocument("UTF-8", "1.0");
        writer.add(startDocument);
        
        // Write root element customer-list
        StartElement startElement = xmlEventFactory.
                createStartElement("", "", "customer-list");
        writer.add(startElement);
        
        // Create attribute
        Attribute attribute = xmlEventFactory.
                createAttribute("version", "1");
        List attributeList = Arrays.asList(attribute);
        List nsList = Arrays.asList();
        StartElement startElement2 = xmlEventFactory.
                createStartElement("", "", "customer",
                attributeList.iterator(), nsList.iterator());
        writer.add(startElement2);
        
        // Write code element with value I001
        StartElement codeSE = xmlEventFactory.
                createStartElement("", "", "code");
        writer.add(codeSE);
        Characters codeChars = xmlEventFactory.
                createCharacters("I001");
        writer.add(codeChars);
        EndElement codeEE = xmlEventFactory.
                createEndElement("", "", "code");
        writer.add(codeEE);
        
        // Write element name with value "ABC Printing"
        StartElement nameSE = xmlEventFactory.createStartElement("", "", "name");
        writer.add(nameSE);
        Characters nameChars = xmlEventFactory.createCharacters("ABC Printing");
        writer.add(nameChars);
        EndElement nameEE = xmlEventFactory.createEndElement("", "", "name");
        writer.add(nameEE);
        
        // Write element contact
        StartElement contactSE = xmlEventFactory.
                createStartElement("", "", "contact");
        writer.add(contactSE);
        Characters contactChars = xmlEventFactory.
                createCharacters("Sean Novell");
        writer.add(contactChars);
        EndElement contactEE = xmlEventFactory.
                createEndElement("", "", "contact");
        writer.add(contactEE);
        
        // Write end document
        EndDocument ed = xmlEventFactory.createEndDocument();
        writer.add(ed);
        
        // Flush and close
        writer.flush();
        writer.close();
    }
}
